from applications.utils import AsyncHttPClient


async def delete_illegal_gzh_articles(gh_id: str, title: str):
    """
    Delete illegal gzh articles
    :param gh_id: gzh id
    :param title: article title
    """
    url = "http://101.37.174.139:80/articleAudit/titleDangerFindDelete"
    payload = {
        "title": title,
        "ghId": gh_id,
    }
    headers = {"Content-Type": "application/json;charset=UTF-8"}
    async with AsyncHttPClient(timeout=600) as client:
        res = await client.post(url=url, headers=headers, json=payload)

    return res
